exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

// Pre- and post-action hooks for Surge

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

exports['default'] = {
  preAuth: function preAuth(req, resume) {
    resume();
  },

  postAuth: function postAuth(req, resume) {
    resume();
  },

  preProject: function preProject(req, resume) {
    _fs2['default'].stat(process.cwd() + '/.flint', function (err, res) {
      var buildDir = _path2['default'].resolve(process.cwd(), '.flint', 'build');

      if (err || !res) {
        console.log("\nRun 'flint build' in a flint repo to build your app first.".green.bold);
      }

      /**
       * Do the Flint compile step here!
       * This is an example where we create
       * a new `200.html` file if there isn’t one,
       * where client side routing
       * and then publish it to Surge.
       *
       * You can replace it with your compile step:
       * await runner.build({ once: true })
       */

      _fs2['default'].writeFile(_path2['default'].resolve(buildDir, '200.html'), '<h1>Hello Flint on ' + new Date().toJSON() + '</h1>', function (err) {
        if (err) throw err;

        /**
         * IMPORTANT
         * We set `req.project` so Surge doesn’t
         * prompt the user for their project dir
         */

        req.project = buildDir;
        resume();
      });
    });
  },

  postProject: function postProject(req, resume) {
    resume();
  },

  preSize: function preSize(req, resume) {
    resume();
  },

  postSize: function postSize(req, resume) {
    resume();
  },

  preDomain: function preDomain(req, resume) {
    resume();
  },

  postDomain: function postDomain(req, resume) {
    resume();
  },

  prePublish: function prePublish(req, resume) {
    resume();
  },

  postPublish: function postPublish(req, resume) {
    resume();
  }
};
module.exports = exports['default'];