exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, 'next'); var callThrow = step.bind(null, 'throw'); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _libFns = require('../lib/fns');

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

var _libLog = require('../lib/log');

var _libLog2 = _interopRequireDefault(_libLog);

var _libHandleError = require('../lib/handleError');

var _libHandleError2 = _interopRequireDefault(_libHandleError);

var OPTS = undefined;

exports['default'] = _asyncToGenerator(function* () {
  try {
    OPTS = _opts2['default']();

    var outFile = _libFns.p(OPTS.buildDir, 'index.html');
    var indexFile = yield _libFns.readFile(_libFns.p(OPTS.flintDir, 'index.html'));

    var template = indexFile.replace(/\/static/g, '/_/static').replace('<!-- STYLES -->', '<link rel="stylesheet" href="/_/styles.css" />')
    // .replace('<!-- EXTERNAL STYLES -->', externalStyles)
    .replace('<!-- SCRIPTS -->', ['<script src="/_/react.prod.js"></script>', '  <script src="/_/flint.prod.js"></script>', '\n  <script>\n    var Flint = exports[\'flint\']\n    Flint.init()\n  </script>\n', '  <script src="/_/externals.js"></script>', '  <script src="/_/internals.js"></script>', '  <script src="/_/' + OPTS.saneName + '.js"></script>', '\n  <script>\n    Flint.run("' + OPTS.saneName + '")\n  </script>\n'].join("\n"));

    _libLog2['default']('makeTemplate writing...');
    yield _libFns.writeFile(outFile, template);
  } catch (e) {
    _libHandleError2['default'](e);
  }
});

function makeIsomorphic() {
  // TODO: flint build --isomorphic
  // if (OPTS.isomorphic) {
  //   var Flint = require('flint-js/dist/flint.node')
  //   var app = require(p(OPTS.buildDir, '_', OPTS.saneName))
  //
  //   var FlintApp = app(false, { Flint }, async function(output) {
  //     template = template.replace(
  //       '<div id="_flintapp"></div>',
  //       '<div id="_flintapp">' + output + '</div>'
  //     )
  //
  //     await writeFile(out, template)
  //   })
  //   return
  // }
}
module.exports = exports['default'];