exports.__esModule = true;

// EXTERNALS
//    check updated
//      => write paths to disk
//      => pack with webpack

var externals = _asyncToGenerator(function* () {
  var opts = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  if (opts.doInstall) yield _install.installAll();

  if (opts.force || _disk2['default'].externalsPaths.hasChanged()) {
    yield* (function* () {
      var paths = yield _disk2['default'].externalsPaths.read();

      yield _disk2['default'].externalsIn.write(function (current, write) {
        write(_libRequireString2['default'](paths));
      });

      yield packExternals();

      if (!opts.silent) _libMessages.onInstalled();
    })();
  }
});

exports.externals = externals;

var installExternals = _asyncToGenerator(function* (filePath) {
  var found = _cache2['default'].getExternals(filePath);
  _libFns.log.externals('installExternals', found);

  if (_opts2['default']('hasRunInitialBuild')) _install.installAll(found);
});

exports.installExternals = installExternals;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, 'next'); var callThrow = step.bind(null, 'throw'); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _libRequires = require('../lib/requires');

var _libWebpackConfig = require('./lib/webpackConfig');

var _libWebpackConfig2 = _interopRequireDefault(_libWebpackConfig);

var _libGetWebpackErrors = require('./lib/getWebpackErrors');

var _libGetWebpackErrors2 = _interopRequireDefault(_libGetWebpackErrors);

var _disk = require('../disk');

var _disk2 = _interopRequireDefault(_disk);

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

var _cache = require('../cache');

var _cache2 = _interopRequireDefault(_cache);

var _libRequireString = require('./lib/requireString');

var _libRequireString2 = _interopRequireDefault(_libRequireString);

var _install = require('./install');

var _libMessages = require('./lib/messages');

var _libFns = require('../lib/fns');

function packExternals() {
  _libFns.log.externals('pack externals');

  return new Promise(function (resolve, reject) {
    var conf = _libWebpackConfig2['default']('externals.js', {
      entry: _opts2['default']('deps').externalsIn
    });

    _libRequires.webpack()(conf, _asyncToGenerator(function* (err, stats) {
      _libFns.logError(_libGetWebpackErrors2['default']('externals', err, stats));
      resolve();
    }));
  });
}