exports.__esModule = true;
exports.onStart = onStart;
exports.onError = onError;
exports.onFinish = onFinish;
exports.onInstalled = onInstalled;
exports.onInternalInstalled = onInternalInstalled;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _bridge = require('../../bridge');

var _bridge2 = _interopRequireDefault(_bridge);

var _opts = require('../../opts');

var _opts2 = _interopRequireDefault(_opts);

var _cache = require('../../cache');

var _cache2 = _interopRequireDefault(_cache);

var _libLog = require('../../lib/log');

var _libLog2 = _interopRequireDefault(_libLog);

// messaging

function avoid() {
  if (_opts2['default']('build') && !_opts2['default']('watch')) return true;

  return !_opts2['default']('hasRunInitialInstall') || !_opts2['default']('hasRunInitialBuild');
}

function onStart(name) {
  if (avoid()) return;
  _bridge2['default'].broadcast('package:install', { name: name });
}

function onError(name, error) {
  if (avoid()) return;
  _bridge2['default'].broadcast('package:error', { name: name, error: error });
  _bridge2['default'].broadcast('npm:error', { error: error });
}

function onFinish(name) {
  if (avoid()) return;
  _libLog2['default']('bundler', 'onPackageFinish: ', name);
  _bridge2['default'].broadcast('package:installed', { name: name });
}

function onInstalled() {
  if (avoid()) return;
  _bridge2['default'].broadcast('packages:reload', {});
}

function onInternalInstalled() {
  if (avoid()) return;
  _bridge2['default'].broadcast('internals:reload', {
    importers: _cache2['default'].getInternalImporters()
  });
}