exports.__esModule = true;

// npm install --save 'name'

var save = _asyncToGenerator(function* (name, index, total) {
  yield _progress2['default']('Installing', 'npm install --save ' + name, name, index, total);
  // npm 3 we need to install peerDependencies as well
  yield installPeerDeps(name);
}

// npm uninstall --save 'name'
);

exports.save = save;

var unsave = _asyncToGenerator(function* (name, index, total) {
  try {
    yield _progress2['default']('Uninstalling', 'npm uninstall --save ' + name, name, index, total);
  } catch (e) {
    // manual uninstall
    yield _libFns.rm(_libFns.p(_opts2['default']('modulesDir'), name));
    yield _disk2['default'].packageJSON.write(function (current, write) {
      delete current.dependencies[name];
      write(current);
    });
  }
});

exports.unsave = unsave;

// TODO: only do this if npm 3 `exec('npm -v').charAt(0) == 3`

var installPeerDeps = _asyncToGenerator(function* (name) {
  // instead of using npm view we just read package.json, safer
  var pkg = yield _libFns.readJSON(_libFns.p(_opts2['default']('flintDir'), 'node_modules', name, 'package.json'));
  var peers = pkg.peerDependencies;

  // install peerdeps
  if (peers && typeof peers == 'object') {
    var peersArr = _normalize2['default'](Object.keys(peers));

    if (peersArr.length) {
      print(('  Installing ' + name + ' peerDependencies').bold);

      var peersFull = peersArr.map(function (name) {
        var version = latestVersion(name, peers[name]);

        if (!version) throw new Error('No valid version range for package ' + name + '@' + peers[name]);

        return name + '@' + version;
      });
      yield Promise.all(peersFull.map(function (full) {
        return _libExecPromise2['default']('npm install --save ' + full, _opts2['default']('flintDir'));
      }));
      print('  ✓'.green, peersArr.join(', '));
      return peersArr;
    }
  }
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, 'next'); var callThrow = step.bind(null, 'throw'); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _disk = require('../../disk');

var _disk2 = _interopRequireDefault(_disk);

var _opts = require('../../opts');

var _opts2 = _interopRequireDefault(_opts);

var _libFns = require('../../lib/fns');

var _libExecPromise = require('../../lib/execPromise');

var _libExecPromise2 = _interopRequireDefault(_libExecPromise);

var _normalize = require('./normalize');

var _normalize2 = _interopRequireDefault(_normalize);

var _progress = require('./progress');

var _progress2 = _interopRequireDefault(_progress);

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

function splitVersions(range) {
  var found = range.match(/[0-9\.]+/g);
  return found.length ? found : range;
}

function latestVersion(name, range) {
  try {
    return _semver2['default'].maxSatisfying(splitVersions(range), range);
  } catch (e) {
    var simpleFindVer = range.replace(/[^0-9\. ]+/g, '').split(' ')[0];

    print(('  Error in semver of package ' + name + ' ' + e.message).yellow);
    print("  Attempting ", simpleFindVer);

    return simpleFindVer;
  }
}exports['default'] = {
  save: save, unsave: unsave
};