exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, 'next'); var callThrow = step.bind(null, 'throw'); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _libExecPromise = require('../../lib/execPromise');

var _libExecPromise2 = _interopRequireDefault(_libExecPromise);

var _sharedConsole = require('../../../shared/console');

var _opts = require('../../opts');

var _opts2 = _interopRequireDefault(_opts);

var _libFns = require('../../lib/fns');

var LOG = 'externals';

exports['default'] = _asyncToGenerator(function* (label, cmd, name, index, total) {
  var spinner = undefined;

  try {
    spinner = logProgress(label, name, index, total);
    yield _libExecPromise2['default'](cmd, _opts2['default']('flintDir'));
    spinner && spinner.stop();
  } catch (e) {
    spinner && spinner.stop();
    if (e.code == 1) throw new Error(cmd + ' failed');
  }
});

function logProgress(tag, name, index, total) {
  if (!_opts2['default']('hasRunInitialBuild')) return;

  _libFns.log('bundler', 'logProgress', tag, name);

  var out = total ? '  ' + (index + 1) + ' of ' + total + ': ' + name : ('  ' + tag + ': ' + name).dim;

  if (_opts2['default']('build') && !_opts2['default']('watch')) print(out);else {
    var spinner = new _sharedConsole.Spinner(out);
    spinner.start({ fps: 15 });
    return spinner;
  }
}
module.exports = exports['default'];