exports.__esModule = true;
exports["default"] = rmFlintExternals;
var filters = [/^babel-runtime(\/.*)?$/, /^react(\/.*)?$/, // TODO allow subpaths
/^flint-js$/, /^react-dom$/, /^history$/, /^radium$/];

function rmFlintExternals(requires) {
  var result = requires.filter(function (fullPath) {
    // babel-runtime/xyz = filtered
    // react/lib = filtered

    for (var _iterator = filters, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var filter = _ref;

      if (filter.test(fullPath)) return false;
    }

    return true;
  });

  return result;
}

module.exports = exports["default"];