exports.__esModule = true;
exports.transformText = transformText;
exports.pointWithinRange = pointWithinRange;
exports.getObjectAtPosition = getObjectAtPosition;
exports.getRowFromText = getRowFromText;

var _flintBabelCore = require('flint-babel-core');

var _gulpScanner = require('../gulp/scanner');

// import { transformPlugin, getBabelConfig } from '../helpers'

var NEWLINE_REGEX = /\r\n|\n|\r/g;
var POSITION_TYPE = {
  VIEW_TOP: 'VIEW_TOP',
  VIEW_JSX: 'VIEW_JSX',
  STYLE: 'STYLE'
};

exports.POSITION_TYPE = POSITION_TYPE;

function transformText(text, _ref) {
  var _ref$log = _ref.log;
  var log = _ref$log === undefined ? null : _ref$log;
  var _ref$writeStyle = _ref.writeStyle;
  var writeStyle = _ref$writeStyle === undefined ? null : _ref$writeStyle;
  var _ref$onMeta = _ref.onMeta;
  var onMeta = _ref$onMeta === undefined ? null : _ref$onMeta;

  // Scanner.pre(false, text, function(text) {
  //   const babelConfig = getBabelConfig({
  //     log, writeStyle, onMeta
  //   })
  //   babelConfig.filename = '__editor__'
  //   babelTransform(text, babelConfig)
  // })
  transformPlugin.disposeLast();
}

function pointWithinRange(point, range) {
  return point.isGreaterThan(range[0]) && point.isLessThan(range[1]);
}

function getObjectAtPosition(objects, position) {
  for (var key in objects) {
    var value = objects[key];
    if (pointWithinRange(position, value.location)) {
      return value;
    }
  }
  return null;
}

function getRowFromText(text, row) {
  var rowText = text.split(NEWLINE_REGEX)[row];
  return rowText || '';
}