exports.__esModule = true;

var app = _asyncToGenerator(function* () {
  try {
    var dest = _libFns.p(_opts2['default']('buildDir'), '_');
    var deps = _opts2['default']('deps');
    var minify = _opts2['default']('config').minify;

    var appFiles = yield _libFns.readdir(_opts2['default']('outDir'));
    appFiles = appFiles.map(function (f) {
      return f.fullPath;
    }).filter(function (x) {
      return !_libHelpers.isSourceMap(x);
    }).sort();

    if (minify) print('  Minifying...'.dim);

    // build parallel
    yield Promise.all([buildForDeploy(deps.internalsOut, { dest: dest, minify: minify }), buildForDeploy(deps.externalsOut, { dest: dest, minify: minify }), buildForDeploy(appFiles, { dest: dest, minify: minify, combine: true, wrap: true })]);
  } catch (e) {
    _libFns.handleError(e);
  }
});

exports.app = app;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, 'next'); var callThrow = step.bind(null, 'throw'); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _flintTransform = require('flint-transform');

var _flintTransform2 = _interopRequireDefault(_flintTransform);

var _babel = require('./babel');

var _babel2 = _interopRequireDefault(_babel);

var _libHelpers = require('./lib/helpers');

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

var _libFns = require('../lib/fns');

function buildForDeploy(src, _ref) {
  var dest = _ref.dest;
  var combine = _ref.combine;
  var minify = _ref.minify;
  var wrap = _ref.wrap;

  return new Promise(function (resolve, reject) {
    _libHelpers.gulp.src(src).pipe(_libHelpers.$.sourcemaps.init())
    // .pipe($.if(combine, $.order(src)))
    .pipe(_libHelpers.$['if'](combine, _libHelpers.$.concat(_opts2['default']('saneName') + '.js'))).pipe(_libHelpers.$['if'](wrap, _babel2['default'].app())).pipe(_libHelpers.$['if'](minify, _libHelpers.$.uglify())).pipe(_libHelpers.$.sourcemaps.write('.')).pipe(_libHelpers.gulp.dest(dest)).on('end', function () {
      _libFns.log.gulp('finished', src);
      resolve();
    }).on('error', reject);
  });
}