exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, 'next'); var callThrow = step.bind(null, 'throw'); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _stream = require('stream');

var _vinyl = require('vinyl');

var _vinyl2 = _interopRequireDefault(_vinyl);

var _chokidar = require('chokidar');

var _chokidar2 = _interopRequireDefault(_chokidar);

var _libFns = require('../../lib/fns');

var _opts = require('../../opts');

var _opts2 = _interopRequireDefault(_opts);

// TODO copying a directory of files over is broken in gulp.watch / gulp-watch
// when a whole dir is copied in, find files and push into stream

var stream = new _stream.Readable({ objectMode: true });
stream._read = function (n) {};

function init(baseDir) {
  _chokidar2['default'].watch(baseDir, {
    ignored: /[\/\\]\./,
    ignoreInitial: true
  }).on('addDir', _asyncToGenerator(function* (dir) {
    try {
      // TODO use globber from gulp
      var files = yield _libFns.readdir(dir, {
        fileFilter: ['*.js'],
        directoryFilter: ['!.git', '!node_modules', '!.flint', '!.*']
      });

      // push
      files.forEach(_asyncToGenerator(function* (_ref) {
        var fullPath = _ref.fullPath;

        var source = yield _libFns.readFile(fullPath);
        var toStream = new _vinyl2['default'](_libFns.vinyl(baseDir, fullPath, new Buffer(source)));
        stream.push(toStream);
      }));
    } catch (e) {
      _libFns.handleError(e);
    }
  }));

  return stream;
}

exports['default'] = init;
module.exports = exports['default'];