exports.__esModule = true;
exports['default'] = setMeta;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

// handles meta info on views passed from babel
// eventually given to atom for IDE

var _bridge = require('../../bridge');

var _bridge2 = _interopRequireDefault(_bridge);

var _cache = require('../../cache');

var _cache2 = _interopRequireDefault(_cache);

var _libExec = require('../../lib/exec');

var _libExec2 = _interopRequireDefault(_libExec);

var meta = {};

function setMeta(_ref) {
  var file = _ref.file;
  var views = _ref.views;

  _cache2['default'].setFileMeta(file, views);
  _bridge2['default'].broadcast('file:meta', { file: file, views: views });
  Object.keys(views).map(function (view) {
    meta[view] = views[view];
  });
}

// send messages for view adds and deletes
// cache.onAddView(view => bridge.message('view:add', { view, meta: meta[view] }))
// cache.onDeleteView(view => bridge.message('view:delete', { view, meta: meta[view] }))

_bridge2['default'].onMessage('editor', function (_ref2) {
  var type = _ref2.type;
  var key = _ref2.key;
  var el = _ref2.el;
  var view = _ref2.view;

  if (type.substr(0, 6) != 'focus:') return;

  if (view === undefined) return;
  // the browser turns One.Two into One-Two
  view = view.replace(/\-/, '.');

  if (!meta[view]) return;

  var data = meta[view].data;

  if (data) {
    var viewData = { name: view, file: data.file };

    if (type == 'focus:style') {
      _bridge2['default'].broadcast('editor:style', {
        view: viewData,
        position: meta[view].styles[el]
      }, 'focus');
    }

    if (type == 'focus:element') {
      if (!view || !key) return;
      _bridge2['default'].broadcast('editor:element', {
        view: viewData,
        position: meta[view].els[key]
      }, 'focus');
    }
  }

  //todo dont focus escape every time
  _libExec2['default']('osascript -e \'activate application "Atom"\'');
});
module.exports = exports['default'];