exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var globCopy = _asyncToGenerator(function* (pattern, dest) {
  var opts = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  var srcs = yield glob(pattern, _extends({ dot: false, nodir: true }, opts));
  yield Promise.all(srcs.map(function (f) {
    return _copy(p(opts.cwd || '', f), p(dest, f));
  }));
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, 'next'); var callThrow = step.bind(null, 'throw'); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _sbPromisify = require('sb-promisify');

var _sbPromisify2 = _interopRequireDefault(_sbPromisify);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _globby = require('globby');

var _globby2 = _interopRequireDefault(_globby);

var _readdirp = require('readdirp');

var _readdirp2 = _interopRequireDefault(_readdirp);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _log = require('./log');

var _log2 = _interopRequireDefault(_log);

var _handleError = require('./handleError');

var _handleError2 = _interopRequireDefault(_handleError);

var _logError = require('./logError');

var _logError2 = _interopRequireDefault(_logError);

var p = _path2['default'].join;

var logWrap = function logWrap(name, fn) {
  return fn;
};
// {
//   return (...args) => {
//     if (!process.env.production)
//       log.file(name && name.dim.bold, ...args.map(arg => (''+arg).dim))
//
//     return fn(...args)
//   }
// }

// promisify
var rm = logWrap('rm', _sbPromisify2['default'](_fsExtra.remove));
var mkdir = logWrap('mkdir', _sbPromisify2['default'](_fsExtra.mkdirs));
var _readdir = _sbPromisify2['default'](_readdirp2['default']);
var readdir = logWrap('readdir', function (dir) {
  var opts = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  return _readdir(Object.assign({ root: dir }, opts)).then(function (res) {
    return res.files;
  });
});
var _readFilePromise = _sbPromisify2['default'](_fsExtra.readFile);
var _readFile = logWrap('readFile', function (file) {
  return _readFilePromise(file, 'utf-8');
});
var _writeFile = _sbPromisify2['default'](_fsExtra.writeFile);
var readJSON = logWrap('readJSON', function (file) {
  return _readFile(file).then(function (res) {
    return JSON.parse(res);
  });
});
var writeJSON = logWrap('writeJSON', function (path, str) {
  return _writeFile(path, JSON.stringify(str));
});
var touch = logWrap('touch', _sbPromisify2['default'](_fsExtra.ensureFile));
var _copy = logWrap('copy', _sbPromisify2['default'](_fsExtra.copy));
var exists = logWrap('exists', _sbPromisify2['default'](_fsExtra.stat));
var glob = logWrap('glob', _globby2['default']);

var recreateDir = function recreateDir(dir) {
  return new Promise(function (res, rej) {
    _fsExtra.remove(dir, function (err) {
      if (err) return rej(err);
      _fsExtra.mkdirs(dir, function (err) {
        if (err) return rej(err);
        res(dir);
      });
    });
  });
};

function sanitize(str) {
  return str.replace(/[^a-zA-Z]/, '');
}

function vinyl(basePath, path, contents) {
  var cwd = '/';
  var base = basePath + '/';
  return { cwd: cwd, base: base, path: path, contents: contents };
}

var debouncers = {};
function debounce(key, time, cb) {
  if (debouncers[key]) clearTimeout(debouncers[key]);
  debouncers[key] = setTimeout(cb, time);
}

exports['default'] = {
  _: _lodash2['default'],
  p: p,
  fs: _fsExtra2['default'],
  debounce: debounce,
  path: _path2['default'],
  mkdir: mkdir,
  rm: rm,
  recreateDir: recreateDir,
  readdir: readdir,
  readJSON: readJSON,
  writeJSON: writeJSON,
  readFile: _readFile,
  writeFile: _writeFile,
  copy: _copy,
  globCopy: globCopy,
  touch: touch,
  exists: exists,
  sanitize: sanitize,
  log: _log2['default'],
  handleError: _handleError2['default'],
  logError: _logError2['default'],
  glob: glob,
  promisify: _sbPromisify2['default'],
  vinyl: vinyl
};
module.exports = exports['default'];