exports.__esModule = true;
exports['default'] = handleError;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _bridge = require('../bridge');

var _bridge2 = _interopRequireDefault(_bridge);

var _raven = require('raven');

var _raven2 = _interopRequireDefault(_raven);

var _logError = require('./logError');

var _logError2 = _interopRequireDefault(_logError);

var _unicodeToChar = require('./unicodeToChar');

var _unicodeToChar2 = _interopRequireDefault(_unicodeToChar);

var errorClient = new _raven2['default'].Client('https://196a18bffe5f4859bb48bbdbef4d6375:d92602c84a694bd6ab31ef3051fe8bd5@app.getsentry.com/55034');

// TODO: document error shape

function handleError(handle) {
  if (!handle) {
    throw new Error('Null error returned');
  }

  // if used for callback
  if (typeof handle == 'function') {
    return function (err) {
      if (err) {
        console.error('ERROR'.red, err);
        process.exit(1);
        return;
      }

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      handle && handle.apply(undefined, args);
    };
  }
  // if used in try/catch
  else {
      // TODO type this
      var error = handle;
      if (!error) return print('  No error!');
      errorClient.captureException(error);

      error.message = _unicodeToChar2['default'](error.message);
      error.stack = _unicodeToChar2['default'](error.stack || error.codeFrame);

      _logError2['default'](error);

      _bridge2['default'].broadcast('compile:error', { error: error }, 'error');
    }
}

module.exports = exports['default'];