exports.__esModule = true;
exports['default'] = logError;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

var _log = require('./log');

var _log2 = _interopRequireDefault(_log);

var _unicodeToChar = require('./unicodeToChar');

var _unicodeToChar2 = _interopRequireDefault(_unicodeToChar);

// TODO clean up error system in general
// This does stuff specific to things that pass in errors, it shouldn't

function logError(error, file) {
  if (!error) return;

  print();

  if (typeof error != 'object' || Array.isArray(error)) return print(error);

  if (error.message) {
    var message = error.message.replace(_opts2['default']('appDir'), '');
    print('  ' + message.red);
  }

  if (error.loc) print('  line: %s, col: %s', error.loc.line, error.loc.column);

  error.stack = error.stack || error.codeFrame || '';

  if (error.plugin == 'gulp-babel') error.stack = error.stack ? error.stack.split("\n").slice(0, 7).join("\n") : '';

  if (error.stack) print(error.stack);

  if (file && typeof file == 'object') _log2['default']('FILE', "\n", file.contents && file.contents.toString());

  print();
}

module.exports = exports['default'];