exports.__esModule = true;

var deleteJS = _asyncToGenerator(function* (view) {
  var file = _fns.p(OPTS.outDir, view + '.js');
  _fns.log('delete js', file);
  yield _fns.rm(file);
});

var deleteStyle = _asyncToGenerator(function* (view) {
  var file = _fns.p(_opts2['default']('styleDir'), view + '.css');
  _fns.log('delete style', file);
  yield _fns.rm(file);
});

exports['default'] = watchDeletes;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, 'next'); var callThrow = step.bind(null, 'throw'); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

var _cache = require('../cache');

var _cache2 = _interopRequireDefault(_cache);

var _bridge = require('../bridge');

var _bridge2 = _interopRequireDefault(_bridge);

var _bundlerInternals = require('../bundler/internals');

var _fns = require('./fns');

function watchDeletes() {
  try {
    _cache2['default'].onDeleteView(_asyncToGenerator(function* (view) {
      _fns.log('onDeleteView', view);
      yield deleteStyle(view);
      _bridge2['default'].broadcast('stylesheet:remove', { view: view });
    }));

    _cache2['default'].onDeleteFile(_asyncToGenerator(function* (_ref) {
      var name = _ref.name;
      var file = _ref.file;
      var state = _ref.state;

      _fns.log('onDeleteFile', name, file, state);

      if (state.isInternal) yield _bundlerInternals.internals();

      yield state.views.forEach(_asyncToGenerator(function* (view) {
        yield deleteStyle(view);
        yield deleteJS(view);
      }));

      _bridge2['default'].broadcast('file:delete', { name: name });
    }));
  } catch (e) {
    _fns.handleError(e);
  }
}

module.exports = exports['default'];