exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, 'next'); var callThrow = step.bind(null, 'throw'); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _autoprefixer = require('autoprefixer');

var _autoprefixer2 = _interopRequireDefault(_autoprefixer);

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _fns = require('./fns');

var _bridge = require('../bridge');

var _bridge2 = _interopRequireDefault(_bridge);

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

var styleDir = undefined;

exports['default'] = _asyncToGenerator(function* (view, sheet) {
  try {
    styleDir = styleDir || _fns.path.join(_opts2['default']('appDir'), '.flint', '.internal', 'styles');
    var file = _fns.path.join(styleDir, view + '.css');
    var prefixed = yield _postcss2['default']([_autoprefixer2['default']]).process(sheet);
    var final = prefixed.css;

    yield _fns.writeFile(file, final);
    if (!_opts2['default']('hasRunInitialBuild')) return;
    _bridge2['default'].broadcast('stylesheet:add', { view: view, file: file });
  } catch (e) {
    _fns.handleError(e);
  }
});
module.exports = exports['default'];